####################################
# LINEAR MODELS WITH INTERACTIONS
####################################

source('TestFunctionsETICS.R')
library("hierNet")
library("glinternet")

fmodel = "welchetal92"; dimx <- 20; ns <- 100
# fmodel = "morretal06"; dimx <- 30; ns <- 100
# fmodel = "loepetal13"; dimx <- 10; ns <- 100
# fmodel = "linketal06dec"; dimx <- 10; ns <- 100
# fmodel = "moon10hdc2"; dimx <- 20; ns <- 100
# fmodel = "moon10hdc3"; dimx <- 20; ns <- 100
# fmodel = "soblev99"; dimx <- 20; ns <- 100
# fmodel = "ishigami"; dimx <- 3; ns <- 100
# fmodel = "gfunc"; dimx <- 20; ns <- 100
# fmodel = "meieretal09a"; dimx <- 200; ns <- 150
# fmodel = "meieretal09b"; dimx <- 80; ns <- 100
# fmodel = "meieretal09c"; dimx <- 80; ns <- 200
# fmodel = "meieretal09d"; dimx <- 60; ns <- 100


X <- runif(ns*dimx)
dim(X) <- c(ns,dimx)
Y <- apply(X,1,fmodel)

####################
# Solve hiernet problem
####################
# Choose regularization parameter by CV (weak)
fitHN=hierNet.path(X,Y)
fitHNcv=hierNet.cv(fitHN,X,Y)
lamhatHN1=fitHNcv$lamhat.1se
# Estimate final model (weak)
fitHN1=hierNet(X,Y,lam=lamhatHN1)
# Visualize estimated effects (weak)
print(fitHN1)

# Choose regularization parameter by CV (strong)
fitHN=hierNet.path(X,Y, strong=TRUE)
fitHNcv=hierNet.cv(fitHN,X,Y)
lamhatHN2=fitHNcv$lamhat.1se
# Estimate final model (strong)
fitHN2=hierNet(X,Y,lam=lamhatH2, strong=TRUE)
# Visualize estimated effects (strong)
print(fitHN2)

####################
# Solve glinternet problem
####################
numLevels = rep(1, dimx)
fitGLcv = glinternet.cv(X, Y, numLevels)
lamhatGL = fitGLcv$lambdaHat
fitGL = glinternet(X, Y, numLevels, lambda=lamhatGL)
coef(fitGL)[[2]]
