####################################
# NONLINEAR ADDITIVE MODELS
####################################


source('TestFunctionsETICS.R')
library("SAM")
library("gamsel")


fmodel = "welchetal92"; dimx <- 20; ns <- 100
# fmodel = "morretal06"; dimx <- 30; ns <- 100
# fmodel = "loepetal13"; dimx <- 10; ns <- 100
# fmodel = "linketal06dec"; dimx <- 10; ns <- 100
# fmodel = "moon10hdc2"; dimx <- 20; ns <- 100
# fmodel = "moon10hdc3"; dimx <- 20; ns <- 100
# fmodel = "soblev99"; dimx <- 20; ns <- 100
# fmodel = "ishigami"; dimx <- 3; ns <- 100
# fmodel = "gfunc"; dimx <- 20; ns <- 100
# fmodel = "meieretal09a"; dimx <- 200; ns <- 150
# fmodel = "meieretal09b"; dimx <- 80; ns <- 100
# fmodel = "meieretal09c"; dimx <- 80; ns <- 200
# fmodel = "meieretal09d"; dimx <- 60; ns <- 100


####################
# Solve gamsel problem
####################
X <- runif(ns*dimx)
dim(X) <- c(ns,dimx)
Y <- apply(X,1,fmodel)
Y <- as.matrix(Y)

gitGScv = cv.gamsel(X,Y)
gamsel.out=gamsel(X,Y,lambda=gitGScv$lambda.min)
plot(gamsel.out,newx=X)
# Bug in package
getActive(gamsel.out, index = NULL, type="nonzero")


####################
# Try classical SAM
####################
X <- runif(ns*dimx)
dim(X) <- c(ns,dimx)
Y <- apply(X,1,fmodel)
Y <- as.matrix(Y)
p <- 3 # nb of spline functions
nlambda <- 500
fitSAM <- samQL(X,Y,nlambda=nlambda,p=p)
# No CV implemented ...
